var BIGAPPLE = (typeof BIGAPPLE === "undefined") ? {} : BIGAPPLE;

BIGAPPLE.MainView = function() {

	// variables
	this.BACKGROUND_HEIGHT = 700;
	this.browserHeight = 0;
	this.browserWidth = 0;
	this.scrollTop = 0;
	this.foregrounds = [];
	this.pages = [];
	this.containers = [];

	this.getJSON = function () {
		// get json data, then init
		scope = this;
		$.getJSON("js/json/data.json", function (data) {
			if (data) {
				scope.createDogNav();
				scope.createMainNav(data.locations);
				scope.createSlideShow(data.images);
				scope.createMap(data.locations);
				scope.getBrowserSize();
				scope.getSections();
				scope.prepContent();
				scope.createListeners();
				scope.adjustSiteStructure();
				scope.browserResized();
				scope.browserScrolled();
			}
		});
	};

	// check for mobiles
	this.checkForMobiles = function() {
		return ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)) || (navigator.userAgent.match(/iPad/i)) || (navigator.userAgent.match(/Android/i)) || (navigator.userAgent.match(/Windows Phone/i)) || (navigator.userAgent.match(/WebOS/i)));
	};

	// get sections
	this.getSections = function () {
		this.pages = $('.page');
		this.dogs = $('.page:not(:eq(0), :eq(1))');
		this.foregrounds = $('.page .foreground');
		this.containers = $('.container');
	};

	// get browser size
	this.getBrowserSize = function () {
		this.browserWidth = $(window).innerWidth();
		if ((navigator.userAgent.match(/iPhone/i)) && !window.navigator.standalone) {
			this.browserHeight = $(window).innerHeight() + 60;
		} else {
			this.browserHeight = $(window).innerHeight();
		}
	};

	// update parallax
	this.updateParallax = function () {
		this.scrollTop = $(window).scrollTop();
		$('#site').css('top', -this.scrollTop);
		for (var i=0, j=this.dogs.length; i<j; i++) {
			if (this.browserWidth > 570) {
				//$(this.dogs[i]).css({"backgroundSize": "auto"});
				var percentage = ((this.scrollTop - ((i+1)*this.browserHeight)) / this.browserHeight) - 1;
				var targetY = ((this.browserHeight/2) - (this.BACKGROUND_HEIGHT/2)) + (((550/2)) * percentage);
				$(this.dogs[i]).css("backgroundPosition", "50% " + targetY + "px");
				targetY = ((this.browserHeight/2) - (this.BACKGROUND_HEIGHT/2)) + (((1050/2)) * percentage);
				$(this.foregrounds[i]).css("backgroundPosition", "50% " + targetY + "px");
			}
		}
	};

	// browser scrolled
	this.browserScrolled = function (e) {
		// var target = "";
		// if($("html").scrollTop() > 0) {
		// 			target = "html";
		// 		} else {
		// 			target = "body";
		// 		}
		// // if ($('body').height() > 0) {
		// // 	target = "body";
		// // } else {
		// // 	target = "html";
		// // }
		this.scrollTop = $('body, html').scrollTop();
		if (!this.checkForMobiles()) {
			this.updateParallax();
		} else {
			$('#nav, #logo').css({'position': 'absolute'}).stop().animate({'top': (this.scrollTop + 25)}, 150);
		}
		this.dogNav.getScrollTop(this.scrollTop, this.browserHeight);
		this.mainNav.getScrollTop(this.scrollTop, this.browserHeight);
	};

	this.browserResized = function () {
		this.getBrowserSize();
		this.slideShow.getBrowserSize(this.browserWidth, this.browserHeight);
		this.map.moveMapControls(this.browserHeight);
		$(this.pages).css({'height' : this.browserHeight, 'width' : this.browserWidth});
		$(this.foregrounds).css({'height' : this.browserHeight, 'width' : this.browserWidth});
		$('#info-blurb').css({'margin' :  ((this.browserHeight - 383) / 2) + "px " + ((this.browserWidth - 873) / 2) + "px"});
		$(this.containers).css({'width' : ((this.browserWidth / 2) - 50), 'margin' : ((this.browserHeight - 450) / 2) + "px auto", 'padding' : '60px 0 0 0'});
		$('.page').css({'backgroundSize' : (this.browserWidth / 4) + " " + (this.browserHeight / 4)});
		// if browser width is under 571 OR under 1024 AND moblie...
		if ( (this.browserWidth < 571) || ((this.browserWidth < 1024) && (this.checkForMobiles() )) ) {
			for (var i=0, j=this.dogs.length; i<j; i++) {
				var descHeight = $(this.dogs[i]).find(".container").outerHeight();
				if(this.browserHeight < 500) {
					$(this.dogs[i]).css({"backgroundPosition": "50% " + descHeight + "px"});
				} else if (this.browserHeight >= 500 && this.browserHeight < 700) {
					$(this.dogs[i]).css({"backgroundPosition": "50% 75%"});
				} else {
					$(this.dogs[i]).css({"backgroundPosition": "50% 50%"});
					$(this.dogs[i]).find('.foreground').css({"backgroundPosition": "50% 50%"});
				}
			}
		}
	};

	this.prepContent = function () {
		if (!this.checkForMobiles()) {
			$('#site').css("position", "fixed");
			var totalHeight = $('.page').length * this.browserHeight;
			$('body').append('<div id="site-height" style="height:' + totalHeight + 'px"></div>');
		} else {
			$('#footer').css('position', 'absolute');
		}
	};

	this.adjustSiteStructure = function () {
		if (!this.checkForMobiles()) {
			var totalHeight = $('.page').length * this.browserHeight;
			$('#site-height').css("height", totalHeight + "px");
		} 
	};

	this.resized = function (e) {
		this.browserResized(e);
		this.adjustSiteStructure(e);
		this.browserScrolled(e);
	};

	this.stopAnimation = function (e) {
		$('body, html').stop();
	};

	this.createListeners = function () {
		var scope = this;
		$(window).on('resize', function (e) {scope.resized(e);});
		$(window).on('orientationchange', function (e) {scope.resized(e);});
		$(window).on('scroll', function (e) {scope.browserScrolled(e);});
		$(window).on('mousewheel', function (e) {scope.stopAnimation(e);});
	};

	this.preventDefaultBehaviour = function (e) {
		e.preventDefault();
		return false;
	};

	this.createMap = function (locations) {
		this.map = new BIGAPPLE.Map(locations);
	};

	this.createDogNav = function () {
		this.dogNav = new BIGAPPLE.DogNavagation();
	};

	this.createMainNav = function (locations) {
		this.mainNav = new BIGAPPLE.Navagation(locations);
	};

	this.createSlideShow = function (images) {
		this.slideShow = new BIGAPPLE.SlideShow(images);
	};

	this.init = function () {
		this.getJSON();
		//$.mobile.loadingMessage=false;
	};

	this.init();

};
		
$(document).ready(function(){
	BIGAPPLE.application = new BIGAPPLE.MainView();
});