BIGAPPLE.Map = function (locationsInfo) {

	this.outsideLondon = false;
	this.maxZoom = 0;
	this.minZoom = 0;
	this.zoomDifference = 0;
	this.sliderHolderHeight = 0;
	this.ZOOM_RATIO = 0;
	this.currentZoom = 0;
	this.currentZoomDifference = 0;
	this.zoomAmount = 0;
	this.offSetY = 0;
	this.ratio = 0;
	this.animating = false;
	this.myOptions = {  panControl: false,
						scaleControl: false,
						mapTypeControl: false,
						scrollwheel: false,
						streetViewControl: false,
						disableDoubleClickZoom: true,
						center: new google.maps.LatLng(51.535755, -0.116570),
						zoom: 14,
						minZoom: 6,
						maxZoom: 18,
						zoomControl: false,
						zoomControlOptions: {
							style: google.maps.ZoomControlStyle.LARGE,
							position: google.maps.ControlPosition.LEFT_CENTER
						},
						mapTypeId: google.maps.MapTypeId.ROADMAP,
						styles: [
								  {
								    featureType: "landscape.man_made",
								    stylers: [
								    	{ visibility: "off" }
								    ]
								  },
								  {
								    featureType: "poi.business",
								    stylers: [
								    	{ visibility: "off" }
								    ]
								  },
								  {
								    featureType: "road",
								    stylers: [
								      { visibility: "on" },
								      { invert_lightness: true },
								      { saturation: -98 },
								      { lightness: 66 }
								    ]
								  },
								  {
								    featureType: "road.highway",
								    stylers: [
								      { visibility: "on" },
								      { lightness: -15 }
								    ]
								  },
								  {
								    featureType: "road.arterial",
								    stylers: [
								      { lightness: -9 }
								    ]
								  },
								  {
								    featureType: "road.arterial",
								    stylers: [
								      { visibility: "on" },
								      { lightness: -6 },
								      { gamma: 0.99 }
								    ]
								  },
								  {
								    featureType: "transit",
								    elementType: "labels",
								    stylers: [
								      { visibility: "off" }
								    ]
								  },
								  {
								    featureType: "poi",
								    stylers: [
								      { visibility: "off" }
								    ]
								  },
								  {
								    featureType: "water",
								    stylers: [
								      { saturation: -100 },
								      { lightness: -11 }
								    ]
								  },
								  {
								    featureType: "transit",
								    stylers: [
								      { visibility: "off" }
								    ]
								  },
								  {
								    featureType: "landscape",
								    stylers: [
								      { saturation: -100 },
								      { visibility: "on" }
								    ]
								  },
								  {
								    featureType: "landscape",
								    elementType: "labels",
								    stylers: [
								      { visibility: "off" }
								    ]
								  },
								  {
								    featureType: "road.arterial",
								    stylers: [
								      { gamma: 9.99 },
								      { visibility: "on" },
								      { lightness: -30 }
								    ]
								  }
								]
		};

		this.locations = []/*[
			{
				position: new google.maps.LatLng(51.526915, -0.084500),
				title: "Old Street Market",
				id: "old-street",
				contents: '<div class="pin"><img src="img/pin.png" alt="Big Apple Hot Dogs" /><div class="right"><h3>OLD STREET CART</h3><p>239 Old Street<br />London EC1V 9EY<br />T: 07989 387 441</p><p>Tues - Fri: 12-6pm</p></div></div>'
			},
			{
				position: new google.maps.LatLng(51.520253, -0.074930),
				title: "Spitalfields Market",
				id: "spitalfields",
				contents: '<div class="pin"><img src="img/pin.png" alt="Big Apple Hot Dogs" /><div class="right"><h3>SPITALFIELDS MARKET</h3><p>239 Old Street<br />London EC1V 9EY<br />T: 07989 387 441</p><p>Tues - Fri: 12-6pm</p></div></div>'
			},
			{
				position: new google.maps.LatLng(51.505764, -0.090680),
				title: "Borough Market",
				id: "borough-market",
				contents: '<div class="pin"><img src="img/pin.png" alt="Big Apple Hot Dogs" /><div class="right"><h3>BOROUGH MARKET</h3><p>239 Old Street<br />London EC1V 9EY<br />T: 07989 387 441</p><p>Tues - Fri: 12-6pm</p></div></div>'
			},
			{
				position: new google.maps.LatLng(51.542705, -0.062485),
				title: "Broadway Market",
				id: "broadway-market",
				contents: '<div class="pin"><img src="img/pin.png" alt="Big Apple Hot Dogs" /><div class="right"><h3>BROADWAY MARKET</h3><p>239 Old Street<br />London EC1V 9EY<br />T: 07989 387 441</p><p>Tues - Fri: 12-6pm</p></div></div>'
			}, 
			{
				position: new google.maps.LatLng(50.211625, -5.478745),
				title: "St Ives",
				id: "st-ives",
				contents: '<div class="pin"><img src="img/pin.png" alt="Big Apple Hot Dogs" /><div class="right"><h3>ST IVES</h3><p>239 Old Street<br />London EC1V 9EY<br />T: 07989 387 441</p><p>Tues - Fri: 12-6pm</p></div></div>'
			},
			{
				position: new google.maps.LatLng(50.820123, -0.142629),
				title: "Brighton",
				id: "brighton",
				contents: '<div class="pin"><img src="img/pin.png" alt="Big Apple Hot Dogs" /><div class="right"><h3>BRIGHTON</h3><p>239 Old Street<br />London EC1V 9EY<br />T: 07989 387 441</p><p>Tues - Fri: 12-6pm</p></div></div>'
			},
			{
				position: new google.maps.LatLng(57.153561, -2.095985),
				title: "Aberdeen",
				id: "aberdeen",
				contents: '<div class="pin"><img src="img/pin.png" alt="Big Apple Hot Dogs" /><div class="right"><h3>ABERDEEN</h3><p>239 Old Street<br />London EC1V 9EY<br />T: 07989 387 441</p><p>Tues - Fri: 12-6pm</p></div></div>'
			}
		]*/;

	this.getLocations = function () {
		var length = locationsInfo.length;
		var locationHTML = "";
		for (var i = 0; i < length; i++) {
			var location = {}
			location.position = new google.maps.LatLng(locationsInfo[i].position.lat, locationsInfo[i].position.lng);
			location.title = locationsInfo[i].title;
			location.id = locationsInfo[i].id;
			location.contents = locationsInfo[i].contents;
			location.london = locationsInfo[i].london;
			if (location.london === false && this.outsideLondon === false) {
				this.outsideLondon = true;
				locationHTML += '<li class="title clear"><h3>Outside London</h3></li>'
			}
			if (i === 0) {
				locationHTML += '<li class="clear">';
			} else {
				locationHTML += "<li>";
			}
			locationHTML += '<a href="' + locationsInfo[i].link + '" id="' + locationsInfo[i].id + '" class="location">';
			locationHTML += locationsInfo[i].title + " " + locationsInfo[i].type + "</a>";
			locationHTML += "</li>";
			this.locations.push(location);
		}
		console.log(locationHTML);
		$("#locations").append(locationHTML);
	};

	this.createMapControls = function () {
		$('#map').append('<div id="map-controls"><a href="#" id="zoom-in" title="Zoom In">zoom in</a><div id="slider-holder" title="Click to Zoom"><a href="#" id="slider" title="Drag To Zoom">slider</a></div><a href="#" id="zoom-out" title="Zoom Out">zoom-out</a></div>');
	};

	this.moveMapControls = function (windowHeight) {
		$('#map-controls').css('top', ((windowHeight / 2) - (212 / 2)));
	};

	this.mapInit = function () {
		this.map = new google.maps.Map(document.getElementById('map_canvas'),
			this.myOptions);

		this.marker = null;
		this.markerArray = [];
		this.infowindow = new google.maps.InfoWindow();
		this.id = ""
		this.position = 0;
		this.thisTitle = "";
		this.clickedMarkerLat = 0;
		this.icon = "";
		this.markerimage = 'img/marker.png';

		this.mcOptions = {
			gridSize : 80, 
			maxZoom : 11,
			imagePath : 'img/marker',
			imageExtention : '.png',
			imageSizes : [109],
			title : 'London Carts',
			averageCenter : true,
			zoomOnClick : false
		};

		for (var i = 0; i < this.locations.length; i++) {

			this.id = this.locations[i].id;
			this.position = this.locations[i].position;
			this.thisTitle = this.locations[i].title;

			this.marker = new google.maps.Marker({
				position: this.locations[i].position,
				map: this.map,
				title: this.locations[i].title,
				icon: this.markerimage
			});

			this.markerArray.push(this.marker);

			this.addEventListeners(this.marker, this.id, this.position, this);
		
		};

		this.mc = new MarkerClusterer(this.map, this.markerArray, this.mcOptions);

	};

	this.moveSlider = function () {
		that = this;
		this.animating = true;
		this.currentZoom = this.map.getZoom();
		this.currentZoomDifference = (this.maxZoom - this.currentZoom);
		$('#slider').stop().animate({'top': (this.currentZoomDifference * this.ZOOM_RATIO)}, 500, function () { that.animating = false });
		this.mc.repaint();
	};
	
	this.stepSlider = function () {
		that = this;
		this.currentZoom = this.map.getZoom();
		this.currentZoomDifference = (this.maxZoom - this.currentZoom);
		$('#slider').css({'top': (this.currentZoomDifference * this.ZOOM_RATIO)});
		this.mc.repaint();
	};
	
	this.calculateZoomRatio = function () {
		this.zoomDifference = (this.maxZoom - this.minZoom);
		this.sliderHolderHeight = 128;
		this.ZOOM_RATIO = (this.sliderHolderHeight/this.zoomDifference);
	};
	
	this.zoomIn = function (e) {
		this.zoomAmount = this.map.getZoom();
	
		if (this.zoomAmount < this.maxZoom - 1) {
			this.map.setZoom(this.zoomAmount + 1);
		}
	
		this.moveSlider();
		e.preventDefault();
		return false;
	};

	this.zoomOut = function (e) {
		this.zoomAmount = this.map.getZoom();
		if (this.zoomAmount > this.minZoom + 1) {
			this.map.setZoom(this.zoomAmount - 1);
		}
	
		this.moveSlider();
		e.preventDefault();
		return false;
	};

	this.changeInfoWindow = function (marker, contents) {
		marker.setIcon('img/markernone.png');
		this.infowindow.setContent(contents);
		this.infowindow.open(this.map, marker);
	};
	
	this.addMarkers = function () {
		for (var i = 0; i < this.locations.length; i++) {
			this.marker = new google.maps.Marker({
				position: this.locations[i].position,
				map: map,
				title: this.locations[i].title
			});
		}
	};

	this.sliderDragged = function (e) {
		this.offSetY = (e.pageY - this.sliderTop);
		this.ratio = (Math.floor(this.offSetY / this.ZOOM_RATIO));
		this.currentZoomAmount = this.map.getZoom();

		if (this.maxZoom > (this.maxZoom - this.ratio) && this.minZoom < (this.maxZoom - this.ratio) ) {
			this.map.setZoom( this.maxZoom - this.ratio );
			this.stepSlider();
		}

		e.preventDefault();
		return false;
	
	};

	this.sliderHolderClicked = function (e) {
		this.offSetY = e.offsetY;
		this.ratio = (Math.floor(this.offSetY / this.ZOOM_RATIO));
		this.currentZoomAmount = this.map.getZoom();
		if ((this.maxZoom - this.ratio) !== this.maxZoom) {
			this.map.setZoom(this.maxZoom - this.ratio);
			this.moveSlider();
		}
		e.preventDefault();
		return false;
	};

	this.openInfoWindow = function (marker) {
		this.infowindow.open(this.map, this.marker);
	};

	this.findClick = function (e) {
		this.clickedMarkerLat = e.latLng.lat();
		for (var i = 0; i < this.locations.length; i++) {
			this.markerArray[i].setIcon("img/marker.png");
			if (this.locations[i].position.lat() === this.clickedMarkerLat) {
				this.changeInfoWindow(this.markerArray[i], this.locations[i].contents);
				this.map.panTo(this.locations[i].position);
				this.map.setZoom (this.myOptions.zoom);
				this.moveSlider();
			}
		}
	};

	this.clearOverlays = function () {
		if (this.markerArray) {
			for (var i = 0; i < this.locations.length; i++) {
				this.markerArray[i].setMap(null);
			}
		}
	};

	this.whichId = function (passedId) {
		for (var i = 0; i < this.locations.length; i++) {
			this.markerArray[i].setIcon("img/marker.png");
			if (this.locations[i].id == passedId) {
				this.markerArray[i].setIcon("img/markernone.png");
				this.changeInfoWindow(this.markerArray[i], this.locations[i].contents);	
				this.map.panTo(this.locations[i].position);
				this.map.setZoom (this.myOptions.zoom);
				this.moveSlider();
			}
		}
	};

	this.zoomChanged = function () {
		this.zoomLevel = this.map.getZoom();
		this.stepSlider();
	};

	this.clusterClicked = function () {
		this.map.setZoom(this.myOptions.zoom);
		this.map.panTo(this.locations[0].position);
		this.changeInfoWindow(this.markerArray[0], this.locations[0].contents);
		this.moveSlider();

	};

	this.infoWindowClosed = function (e) {
		this.infowindow.close();

		for (var i = 0; i < this.locations.length; i++) {
			this.markerArray[i].setIcon("img/marker.png");
		}
	};
	
	 this.mouseDown = function (e, scope) {
	 	this.offset = $('#slider-holder').offset();
		this.sliderTop = this.offset.top;
		this.sliderBottom = (this.offset.top + 128);
		$(window).bind("mousemove.map", function (e) {scope.mouseMove(e, scope)});
		$(window).bind('mouseup.map', function(e) {scope.mouseUp(e, scope)});
		e.preventDefault();
	};
 	
	this.mouseMove = function (e, scope) {
		e.preventDefault;
		this.sliderDragged(e)
	};
	
	this.mouseUp = function (e, scope) {
		$(window).unbind('mousemove.map');
		$(window).unbind('mouseup.map');
	};
	
	this.sliderTouchDragged = function (evt) {
		this.offSetY = (evt.originalEvent.changedTouches[0].pageY - this.sliderTop);
		this.ratio = (Math.floor(this.offSetY / this.ZOOM_RATIO));
		this.currentZoomAmount = this.map.getZoom();

		if (this.maxZoom > (this.maxZoom - this.ratio) && this.minZoom < (this.maxZoom - this.ratio) ) {
			this.map.setZoom( this.maxZoom - this.ratio );
			this.stepSlider();
		}

		evt.preventDefault();

	};

	this.touchEnd = function (e, scope) {
		e.preventDefault();
		e.bubbles = false;
		$(window).unbind('touchmove.map');
		$(window).unbind('touchend.map');
		setTimeout("$('#slider-holder').bind('click', function (e) {this.sliderHolderClicked(e)})", 100);
	};

	this.touchMove = function (e, scope) {
		e.preventDefault();
		this.sliderTouchDragged(e);
	};

	this.touchStart = function (e, scope) {
		e.preventDefault;
		this.offset = $('#slider-holder').offset();
		this.sliderTop = this.offset.top;
		this.slideBottom = this.offset.top + 128;
		$('#slider-holder').unbind('click');
		$(window).bind('touchmove.map', function(evt) {scope.touchMove (evt, scope)});
		$(window).bind('touchend.map', function(evt) {scope.touchEnd (evt, scope)});
	};

	this.addClusterEventListener = function (scope) {
		google.maps.event.addListener(this.mc, 'click', function () {scope.clusterClicked();})
		google.maps.event.addListener(this.infowindow, 'closeclick', function (e) {scope.infoWindowClosed(e);});
		google.maps.event.addDomListener(document.getElementById('zoom-in'), 'click', function (e) {scope.zoomIn(e)});
		google.maps.event.addDomListener(document.getElementById('zoom-out'), 'click', function (e) {scope.zoomOut(e)});
		$('#slider-holder').bind('click', function (e) {scope.sliderHolderClicked(e)});
		$('#slider').bind('mousedown', function(e) {scope.mouseDown(e, scope)});
		$('#slider').bind('touchstart', function(e) {scope.touchStart(e, scope)});
	};

	this.addEventListeners = function (marker, id, position, scope) {
		google.maps.event.addDomListener(document.getElementById(id), 'click', function () {scope.map.panTo(position);scope.whichId(id);});
		google.maps.event.addListener(this.marker, 'click', function (e) {scope.findClick(e);});//infowindow.open(map, marker);})
		google.maps.event.addListener(this.map, 'zoom_changed', function (e) {scope.zoomChanged();});
	};

	this.getDefaults = function () {
		this.maxZoom = this.myOptions.maxZoom;
		this.minZoom = this.myOptions.minZoom;
		this.calculateZoomRatio();
	};
	
	this.init = function () {
		this.getLocations();	
		this.getDefaults();
		this.mapInit();
		this.createMapControls();
		this.moveSlider();
		this.changeInfoWindow (this.markerArray[0], this.locations[0].contents);
		this.addClusterEventListener(this);
	};

	this.init();

};