BIGAPPLE.Navagation = function (locations) {

	this.scrollTop = 0;
	this.browserHeight = 0;
	this.animating = false;
	this.locationName = "";
	this.locationHeight = 0;
	this.browserWidth = 0;

	this.checkForMobiles = function() {
		return ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)) || (navigator.userAgent.match(/iPad/i)) || (navigator.userAgent.match(/Android/i)) || (navigator.userAgent.match(/Windows Phone/i)) || (navigator.userAgent.match(/WebOS/i)));
	};

	this.prepLocations = function () {
		// 18 is location height
		locationHeight = $('#locations').height() + (locations.length * 18);
		if (this.browserWidth < 571) {
			locationHeight += 25;
		}
		$('#locations').hide();
	};

	this.getScrollTop = function (newScrollTop, newBrowserHeight) {
		this.scrollTop = newScrollTop;
		this.browserHeight = newBrowserHeight;
		this.checkScrollTop();
	};

	this.locationButton = function () {
		if (this.scrollTop > (this.browserHeight-1) || (!this.checkForMobiles() && this.scrollTop > (this.browserHeight))) {
			$('#location-button').removeClass('active');
			$('#location-button').removeClass('open');
			if (this.browserWidth < 571) {
				$('#location-button span').text('LOCATIONS')
			} else {
				$('#location-button span').text('Our Locations');
			}
			this.hideLocations();
		} else {
			if (!$('#location-button').hasClass('active')) {
				$('#location-button').addClass('active');
			}
		}
	};

	this.aboutButton = function () {
		if (this.scrollTop >= this.browserHeight && this.scrollTop < this.browserHeight * 2 ) {
			$('#about-button').addClass('active');
		} else {
			if ($('#about-button').hasClass('active')) {
				$('#about-button').removeClass('active');
			}
		};
	};

	this.menuButton = function () {
		if (this.scrollTop >= this.browserHeight * 2) {
			$('#menu-button').addClass('active');
		} else {
			if ($('#menu-button').hasClass('active')) {
				$('#menu-button').removeClass('active');
			}
		};
	};

	this.checkScrollTop = function () {
		this.locationButton();
		this.aboutButton();
		this.menuButton();
	};

	this.hideLocations = function () {
		then = this;
		if (this.animating === false) {
			this.animating = true;
			$('#locations').slideUp(500);
			$('a#location-button.active').removeClass('open');
			$('#about-box').animate({'marginTop' : 0 }, 500, function () {then.animating = false;});
		}
	};

	this.showLocations = function () {
		then = this;
		var marginTop = 0;
		if (this.animating === false) {
			this.animating = true;
			$('#locations').slideDown(500);
			$('a#location-button.active').addClass('open');
			// 10 is margin
			// not iphone
			if ($('#location-box h3').length === 1) {
				marginTop = ($('#location-box h2').height() / 2) + (locationHeight) - 10;
			} else {
				marginTop = (($('#location-box h2').height() / 2) + $('#location-box h3').innerHeight()) + (locationHeight) - 10;
			}
			$('#about-box').animate({'marginTop' : marginTop }, 500, function () {then.animating = false;});
		}
	};

	this.locationButtonClicked = function (e) {
		scope = this;

		if (this.scrollTop < this.browserHeight) {
			if ($('#locations').css('display') === 'none') {
				this.showLocations();
			} else {
				this.hideLocations();
			}
		} else {
			if ($('#locations').css('display') === 'none') {
				var target = "";
				// if ($('body').height() > 0) {
				// 	target = "body";
				// } else {
				// 	target = "html";
				// }
				// if($("html").scrollTop() > 0) {
				// 	target = "html";
				// } else {
				// 	target = "body";
				// }
				$("body, html").stop().animate({'scrollTop' : 0}, (this.scrollTop / this.browserHeight) * 500, function() {scope.showLocations();});
			} else {
				this.hideLocations();
				$('#location-button').removeClass('active');
			}
			if (this.checkForMobiles()) {
			 	$('#nav, #logo').css({'position': '', 'top': ''});
			}
		}

		e.preventDefault();
		return false;
	};
	
	this.aboutButtonClicked = function (e) {
		if (this.scrollTop < this.browserHeight) {
			this.scrollTop = this.browserHeight;
		}
		var target = "";
		// if ($('body').height() > 0) {
		// 	target = "body";
		// } else {
		// 	target = "html";
		// }
		// if($("html").scrollTop() > 0) {
		// 	target = "html";
		// } else {
		// 	target = "body";
		// }
		$("body, html").stop().animate({'scrollTop' : (this.browserHeight)}, (this.scrollTop / this.browserHeight) * 500);
	
		//if (this.checkForMobiles()) {
		//	$('#nav, #logo').css({'position': 'absolute', 'top': (this.browserHeight + 25)});
		//}
	
		e.preventDefault();
		return false;
	};

	this.menuButtonClicked = function (e) {
		var target = "";
		// if ($('body').height() > 0) {
		// 	target = "body";
		// } else {
		// 	target = "html";
		// }
		// if($("html").scrollTop() > 0) {
		// 	target = "html";
		// } else {
		// 	target = "body";
		// }
		$("body, html").stop().animate({'scrollTop' : (this.browserHeight * 2)}, (((this.browserHeight) / this.browserHeight) * 500));
		if (this.checkForMobiles()) {
			$('#nav, #logo').css({'position': 'absolute', 'top': ((this.browserHeight * 2) + 25)});
		}
		e.preventDefault();
		return false;
	};

	this.locationClicked = function (e) {
		this.browserWidth = $(window).width();
		this.locationName = e.currentTarget;

		if (this.browserWidth < 571) {
			// normal
			//$('#location-box span').text(this.locationName.text);
			var url = (($(e.currentTarget)).attr('href'));
			window.open(url);
			e.preventDefault();
			return false;
		} else {
			$('#location-box span').text(this.locationName.text);
			e.preventDefault();
			return false;
		}
	};

	this.seeMoreButtonClicked = function (e) {
		if (this.scrollTop < this.browserHeight) {
			this.scrollTop = this.browserHeight;
		}
		var target = "";
		// if ($('body').height() > 0) {
		// 	target = "body";
		// } else {
		// 	target = "html";
		// }
		// if($("html").scrollTop() > 0) {
		// 	target = "html";
		// } else {
		// 	target = "body";
		// }
		$("body, html").stop().animate({'scrollTop' : (this.browserHeight)}, (this.scrollTop / this.browserHeight) * 500);
		e.preventDefault();
		return false;
	};

	this.onWindowResized = function (e) {
		this.browserWidth = $(window).innerWidth();
		if (this.browserWidth < 571) {
			if ($('#location-button span').text() !== "LOCATIONS") {
				$('#location-button span').text("LOCATIONS");
				$('#about-button span').text("ABOUT");
				$('#menu-button span').text("MENU");
			}
		} else if (this.browserWidth < 1024) {
			if ($('#about span').text() !== "About") {
				$('#location-button span').text("Our Locations");
				$('#about-button span').text("About");
				$('#menu-button span').text("Menu");
			}
		} else {
			if ($('#about-button span').text() === "About" || $('#location-button span').text() === "LOCATIONS") {
				$('#location-button span').text("Our Locations");
				$('#about-button span').text("About Big Apple Hot Dogs");
				$('#menu-button span').text("Our Hot Dogs");
			}
		}
	};

	this.createListeners = function () {
		var scope = this;
		$('#location-button').on('click', function (e) {scope.locationButtonClicked(e)});
		$('#see-more-button').on('click', function (e) {scope.seeMoreButtonClicked(e)});
		$('#about-button').on('click', function (e) {scope.aboutButtonClicked(e)});
		$('#menu-button').on('click', function (e) {scope.menuButtonClicked(e)});
		$('.location').live('click', function (e) {scope.locationClicked(e)});
		$(window).on('resize', function (e) {scope.onWindowResized(e);});
	};

	this.getBrowserSize = function () {
		this.browserWidth = $(window).innerWidth();
		if ((navigator.userAgent.match(/iPhone/i)) && !window.navigator.standalone) {
			this.browserHeight = $(window).innerHeight() + 60;
		} else {
			this.browserHeight = $(window).innerHeight();
		}
	};

	this.init = function () {
		this.getBrowserSize();
		this.createListeners();
		this.onWindowResized();
		this.prepLocations();
	};

	this.init();

};