BIGAPPLE.SlideShow = function (addedSlides) {

	this.browserHeight = 0;
	this.browserWidth = 0;
	this.scrollTop = 0;
	this.ORIGINAL_IMAGE_WIDTH = 1920;
	this.ORIGINAL_IMAGE_HEIGHT = 1080;
	this.imageRatio = 0;
	this.oppositeImageRatio = 0;
	this.browserRatio = 0;
	this.imageWidth = 0;
	this.imageHeight = 0;
	this.leftAmount = 0;
	this.slideNumber = 1;
	this.animating = false;
	this.imageArray = [];
	this.minLength = 72;
	this.fingerCount = 0;
	this.startX = 0;
	this.startY = 0;
	this.curX = 0;
	this.curY = 0;
	this.deltaX = 0;
	this.deltaY = 0;
	this.horzDiff = 0;
	this.vertDiff = 0;
	this.swipeLength = 0;
	this.swipeAngle = null;
	this.swipeDirection = null;

	this.checkForMobiles = function() {
		return ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)) || (navigator.userAgent.match(/iPad/i)) || (navigator.userAgent.match(/Android/i)) || (navigator.userAgent.match(/Windows Phone/i)) || (navigator.userAgent.match(/WebOS/i)));
	};

	this.getBrowserRatio = function () {
		this.browserRatio = (this.browserWidth / this.browserHeight);
	};

	this.changeSlideSize = function () {
		this.getBrowserRatio();
		if (this.browserRatio < this.imageRatio) {
			$('.slide img').css({height: this.browserHeight, width: (this.imageRatio * this.browserHeight)});
		} else {
			$('.slide img').css({width: this.browserWidth, height: (this.oppositeImageRatio * this.browserWidth)});
		}
		$('.slide img').css({'left': (this.browserWidth / 2) - ($('.slide img').width() / 2), top:(this.browserHeight / 2) - ($('.slide img').height() / 2)})
		this.leftAmount = $(window).innerWidth() * (this.slideNumber - 1);
		$('#slide-container-container').scrollLeft(this.leftAmount);
	};

	this.changeNav = function () {
		// +1 for first slide with no image
		$('#slide-container').css('width', this.browserWidth * (this.imageArray.length + 1));
		$('.slide').css({'height':this.browserHeight,'width':this.browserWidth});
		if (this.browserWidth > 1024) {
			$('.left, .right').css('top', ((this.browserHeight/2) - 30) + "px");
		} else {
			$('.left, .right').css('top', (this.browserHeight - 150) + "px");
		}
		this.changeSlideSize();
	};

	this.getBrowserSize = function (newBrowserWidth, newBrowserHeight) {
		this.browserWidth = newBrowserWidth;
		this.browserHeight = newBrowserHeight;
		// var target = "";
		// if($("html").scrollTop() > 0) {
		// 	target = "html";
		// } else {
		// 	target = "body";
		// }
		// if ($('body').height() > 0) {
		// 	target = "body";
		// } else {
		// 	target = "html";
		// }
		this.scrollTop = $("html, body").scrollTop();
		this.changeNav();
	};

	this.createNav = function () {
		$('#container').prepend('<a href="#" class="right">prev</a><a href="#" class="left">next</a>');
		$('.left').css('opacity', 0.5);
	};

	this.slideLeft = function () {
		that = this;
		if (this.animating === false && this.slideNumber < this.imageArray.length + 1) {
			this.animating = true;
			if (!this.checkForMobiles()) {
				// var target = "";
				// if($("html").scrollTop() > 0) {
				// 	target = "html";
				// } else {
				// 	target = "body";
				// }
				// if ($('body').height() > 0) {
				// 	target = "body";
				// } else {
				// 	target = "html";
				// }
				$("html, body").stop().animate({'scrollTop' : (this.browserHeight)}, 1000);
			}
			this.leftAmount += this.browserWidth;
			this.slideNumber++;
			if (this.slideNumber > 1) {
				$('.left').css('opacity', 1);
			}
			if (this.slideNumber === this.imageArray.length + 1) {
				$('.right').css('opacity', 0.5);
			}
			$('#slide-container-container').stop().animate({scrollLeft:this.leftAmount}, 1000,  'easeOutQuad',  function () {that.animating = false; });
		}
	};

	this.leftClicked = function (e) {
		this.slideRight();
		e.preventDefault();
		return false;
	};

	this.addSlides = function () {
		for (var i = 0; i < this.imageArray.length; i++) {
			$('#slide-container').append('<div class="slide"><img src="' + this.imageArray[i] + '" /></div>');
		}
	};

	this.slideRight = function () {
		that = this;
		if (this.animating === false && this.slideNumber !== 1) {
			this.animating = true;
			if (!this.checkForMobiles()) {
				var target = "";
				// if($("html").scrollTop() > 0) {
				// 	target = "html";
				// } else {
				// 	target = "body";
				// }
				// if ($('body').height() > 0) {
				// 	target = "body";
				// } else {
				// 	target = "html";
				// }
				$("html, body").stop().animate({'scrollTop' : (this.browserHeight)}, 1000);
			}
			this.leftAmount -= this.browserWidth;
			this.slideNumber--;
			if (this.slideNumber === 1) {
				$('.left').css('opacity', 0.5);
			}
			if (this.slideNumber < this.imageArray.length + 1) {
				$('.right').css('opacity', 1);
			}
			$('#slide-container-container').stop().animate({'scrollLeft' :this.leftAmount}, 1000, 'easeOutQuad', function () {that.animating = false; });
		}
	};

	this.rightClicked = function (e) {
		this.slideLeft();
		e.preventDefault();
		return false;
	};
 
	this.createListeners = function () {
		thus = this;
		$('.left').on('click', function (e) {thus.leftClicked(e)});
		$('.right').on('click', function (e) {thus.rightClicked(e)});
	};

	this.onBrowserResize = function (e) {
		this.leftAmount = $(window).innerWidth() * this.slideNumber;
		$('#slide-container-container').scrollLeft(this.leftAmount);
	};

	this.createSlides = function () {
		this.imageArray = addedSlides;
	};

	this.createDefaults = function () {
		this.imageRatio = (this.ORIGINAL_IMAGE_WIDTH / this.ORIGINAL_IMAGE_HEIGHT);
		this.oppositeImageRatio = (this.ORIGINAL_IMAGE_HEIGHT / this.ORIGINAL_IMAGE_WIDTH)
	};

	/*

	this.createTouchListeners = function () {
		scope = this;
		$('#about').bind('touchstart', function(e) {scope.touchStart(e)});
		$('#about').bind('touchmove', function(e) {scope.touchMove(e)});
		$('#about').bind('touchend', function(e) {scope.touchEnd(e)});
		$('#about').bind('touchcancel', function(e) {scope.touchCancel(e)});
	};

	// swipe support

	this.touchStart = function (event) {
		// disable the standard ability to select the touched object
		//event.preventDefault();
		// get the total number of fingers touching the screen
		this.fingerCount = event.originalEvent.touches.length;
		// since we're looking for a swipe (single finger) and not a gesture (multiple fingers),
		// check that only one finger was used
		if ( this.fingerCount == 1 ) {
			// get the coordinates of the touch
			this.startX = event.originalEvent.touches[0].pageX;
			this.startY = event.originalEvent.touches[0].pageY;
			// store the triggering element ID
			//triggerElementID = passedName;
		} else {
			// more than one finger touched so cancel
			this.touchCancel(event);
		}
	};

	this.touchMove = function (event) {
		//event.preventDefault();
		if ( event.originalEvent.touches.length == 1 ) {
			this.curX = event.originalEvent.touches[0].pageX;
			this.curY = event.originalEvent.touches[0].pageY;
			//console.log(this.startX - this.curX);
			$('#slide-container-container').scrollLeft(this.leftAmount + (this.startX - this.curX));
		} else {
			this.touchCancel(event);
		}
	};
	
	this.touchEnd = function (event) {
		event.preventDefault();
		var cancelled = true;
		// check to see if more than one finger was used and that there is an ending coordinate
		if ( this.fingerCount == 1 && this.curX != 0 ) {
			// use the Distance Formula to determine the length of the swipe
			this.swipeLength = Math.round(Math.sqrt(Math.pow(this.curX - this.startX,2) + Math.pow(this.curY - this.startY,2)));
			// if the user swiped more than the minimum length, perform the appropriate action
			if ( this.swipeLength >= this.minLength ) {
				this.calculateAngle();
				this.determineSwipeDirection();
				this.processingRoutine(event);
				this.touchCancel(event); // reset the variables
			} else {
				this.touchCancel(event,cancelled);
			}	
		} else {
			this.touchCancel(event,cancelled);
		}
	};

	this.touchCancel = function (event, cancelled) {
		// reset the variables back to default values
		this.fingerCount = 0;
		this.startX = 0;
		this.startY = 0;
		this.curX = 0;
		this.curY = 0;
		this.deltaX = 0;
		this.deltaY = 0;
		this.horzDiff = 0;
		this.vertDiff = 0;
		this.swipeLength = 0;
		this.swipeAngle = null;
		this.swipeDirection = null;
		this.triggerElementID = null;
		if (cancelled === true) {
			$('#slide-container-container').stop().animate({'scrollLeft' :this.leftAmount}, 100, 'easeOutQuad');
		}
	};
	
	this.calculateAngle = function () {
		var X = this.startX-this.curX;
		var Y = this.curY-this.startY;
		var Z = Math.round(Math.sqrt(Math.pow(X,2)+Math.pow(Y,2))); //the distance - rounded - in pixels
		var r = Math.atan2(Y,X); //angle in radians (Cartesian system)
		this.swipeAngle = Math.round(r*180/Math.PI); //angle in degrees
		if ( this.swipeAngle < 0 ) { this.swipeAngle =  360 - Math.abs(this.swipeAngle); }
	};
	
	this.determineSwipeDirection = function (e) {
		if ( (this.swipeAngle <= 45) && (this.swipeAngle >= 0) ) {
			this.swipeDirection = 'left';
		} else if ( (this.swipeAngle <= 360) && (this.swipeAngle >= 315) ) {
			this.swipeDirection = 'left';
		} else if ( (this.swipeAngle >= 135) && (this.swipeAngle <= 225) ) {
			this.swipeDirection = 'right';
		} else if ( (this.swipeAngle > 45) && (this.swipeAngle < 135) ) {
			this.swipeDirection = 'down';
		} else {
			this.swipeDirection = 'up';
		}
	};
	
	this.processingRoutine = function (e) {
		if ( this.swipeDirection == 'left' ) {
			this.rightClicked(e)
		} else if ( this.swipeDirection == 'right' ) {
			this.leftClicked(e);
		} else if ( this.swipeDirection == 'up' ) {
			// do nothing
		} else if ( this.swipeDirection == 'down' ) {
			// do nothing
		}
	};

	*/

	this.init = function () {
		this.createNav();
		this.createListeners();
		//this.createTouchListeners();
		this.createDefaults();
		this.createSlides();
		this.addSlides();
	};

	this.init();

};