////////////////////////////////////////////////////////////////////////////////
// Big Apple Hot Dogs Styled Google Map
////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------
// Constructor
//------------------------------------------------
bigapple.views.main.StyledMap = function() {
	this.init();
	return this;
};

bigapple.views.main.StyledMap.prototype = (function() {
	
	var _public = {
		//------------------------------------------------
		// Init
		//------------------------------------------------
		init:function() {
			_private.setup();
		}
	};
	
	var _private = {
		//------------------------------------------------
		// Variables
		//------------------------------------------------
		map: null,
		
		//------------------------------------------------
		// Set up nav
		//------------------------------------------------
		setup:function() {
			this.createMap();
			this.createBubble();
		},
		
		//------------------------------------------------
		// Styles for Big Apple map
		//------------------------------------------------
		getStyles:function() {
			return [
				{
					featureType: "all",
					stylers: [
						{saturation: -100}
					]
				},
				{
					featureType: "landscape",
					elementType: "all",
					stylers: [
						{hue: "#f4e481"},
						{saturation: 80},
						{lightness: -16}
					]
				},
				{
					featureType: "road.arterial",
					elementType: "all",
					stylers: [
						{hue: "#d7a244"},
						{saturation: 70},
						{lightness: -16}
					]
				},
				{
					featureType: "road.local",
					elementType: "geometry",
					stylers: [
						{hue: "#ffff9d"},
						{saturation: 80},
						{lightness: -16}
					]
				},
				{
					featureType: "road.highway",
					elementType: "all",
					stylers: [
						{hue: "#ddaf50"},
						{saturation: 60},
						{lightness: -16}
					]
				},
				{
					featureType: "water",
					elementType: "all",
					stylers: [
						{hue: "#f4da81"},
						{saturation: 80},
						{lightness: -16}
					]
				},
				{
					featureType: "poi",
					elementType: "geometry",
					stylers: [
						{hue: "#f4da81"},
						{saturation: 80},
						{lightness: -16}
					]
				}
			];
		},
		
		//------------------------------------------------
		// Create Google map
		//------------------------------------------------
		createMap:function() {
			var latlng = new google.maps.LatLng(51.527943, -0.085444);
			var options = {
				zoom: 16,
				center: latlng,
				mapTypeControlOptions: {
					mapTypeIds: [google.maps.MapTypeId.ROADMAP, "BigAppleMap"]
				},
				disableDefaultUI: true,
				mapTypeId: "BigAppleMap"
			};
			var styles = this.getStyles();
			this.map = new google.maps.Map(document.getElementById("map"), options);
			var mapStyle = new google.maps.StyledMapType(styles, options);
			this.map.mapTypes.set("BigAppleMap", mapStyle);
		},
		
		//------------------------------------------------
		// Add Big Apple bubble to map
		//------------------------------------------------
		createBubble:function() {
			var html = "<div id='logo'><div class='details'><h1>Big Apple Hot Dogs</h1><dl><dt>Address</dt><dd>239 Old Street<br />London EC1V 9EY</dd><dt>Telephone Number</dt><dd>T: 07968 043 245</dd><dt>Opening Hours</dt><dd id='opening-hours'>Tues - Fri: 12-6pm</dd></dl><p>No brains, no bones, no butts. The best dog you've ever had. Guaranteed.</p></div></div>";
			var marker = new google.maps.Marker({
				map: this.map,
				draggable: true,
				position: new google.maps.LatLng(51.526395, -0.085123),
				visible: false
			});
			var bubbleOptions = {
				content: html,
				disableAutoPan: false,
				maxWidth: 0,
				pixelOffset: new google.maps.Size(-181, -230),
				zIndex: null,
				boxStyle: {
					opacity: 1,
					width: "348px"
				},
				closeBoxURL: "",
				infoBoxClearance: new google.maps.Size(1, 1),
				isHidden: false,
				pane: "floatPane",
				enableEventPropagation: false
			};
			var bubble = new InfoBox(bubbleOptions);
			bubble.open(this.map, marker);
		},
	};
	
	return _public;
}());